//
// Generated by Bluespec Compiler (build 9370759)
//
// On Thu Jul 23 15:22:00 IST 2020
//
//
// Ports:
// Name                         I/O  size props
// uart0_SOUT                     O     1 reg
// gpio_in_en                     O    22 reg
// gpio_out_val                   O    22
// gpio_out_en                    O    22 reg
// gpio_pullup_en                 O    22 reg
// gpio_drive_0                   O    22 reg
// gpio_drive_1                   O    22 reg
// gpio_drive_2                   O    22 reg
// ddr_AWVALID                    O     1
// ddr_AWID                       O     1 reg
// ddr_AWADDR                     O    32 reg
// ddr_AWLEN                      O     8 reg
// ddr_AWSIZE                     O     3 reg
// ddr_AWBURST                    O     2 reg
// ddr_AWLOCK                     O     1 reg
// ddr_AWCACHE                    O     4 reg
// ddr_AWPROT                     O     3 reg
// ddr_AWQOS                      O     4 reg
// ddr_AWREGION                   O     4 reg
// ddr_WVALID                     O     1
// ddr_WDATA                      O    64 reg
// ddr_WSTRB                      O     8 reg
// ddr_WLAST                      O     1 reg
// ddr_BREADY                     O     1
// ddr_ARVALID                    O     1
// ddr_ARID                       O     1 reg
// ddr_ARADDR                     O    32 reg
// ddr_ARLEN                      O     8 reg
// ddr_ARSIZE                     O     3 reg
// ddr_ARBURST                    O     2 reg
// ddr_ARLOCK                     O     1 reg
// ddr_ARCACHE                    O     4 reg
// ddr_ARPROT                     O     3 reg
// ddr_ARQOS                      O     4 reg
// ddr_ARREGION                   O     4 reg
// ddr_RREADY                     O     1
// open_AWVALID                   O     1
// open_AWID                      O     1 reg
// open_AWADDR                    O    32 reg
// open_AWLEN                     O     8 reg
// open_AWSIZE                    O     3 reg
// open_AWBURST                   O     2 reg
// open_AWLOCK                    O     1 reg
// open_AWCACHE                   O     4 reg
// open_AWPROT                    O     3 reg
// open_AWQOS                     O     4 reg
// open_AWREGION                  O     4 reg
// open_WVALID                    O     1
// open_WDATA                     O    64 reg
// open_WSTRB                     O     8 reg
// open_WLAST                     O     1 reg
// open_BREADY                    O     1
// open_ARVALID                   O     1
// open_ARID                      O     1 reg
// open_ARADDR                    O    32 reg
// open_ARLEN                     O     8 reg
// open_ARSIZE                    O     3 reg
// open_ARBURST                   O     2 reg
// open_ARLOCK                    O     1 reg
// open_ARCACHE                   O     4 reg
// open_ARPROT                    O     3 reg
// open_ARQOS                     O     4 reg
// open_ARREGION                  O     4 reg
// open_RREADY                    O     1
// wire_tdo                       O     1
// io_dump_get                    O   168
// RDY_io_dump_get                O     1 reg
// qspi_io_clk_o                  O     1
// qspi_io_io_o                   O     4 reg
// qspi_io_io_enable              O     4 reg
// qspi_io_ncs_o                  O     1 reg
// RST_N_soc_reset                O     1 reset
// CLK_tck_clk                    I     1 clock
// RST_N_trst                     I     1 reset
// CLK                            I     1 clock
// RST_N                          I     1 reset
// uart0_SIN                      I     1 reg
// boot_config                    I     2 reg
// gpio_in_val                    I    22 reg
// ddr_AWREADY                    I     1
// ddr_WREADY                     I     1
// ddr_BVALID                     I     1
// ddr_BID                        I     1 reg
// ddr_BRESP                      I     2 reg
// ddr_ARREADY                    I     1
// ddr_RVALID                     I     1
// ddr_RID                        I     1 reg
// ddr_RDATA                      I    64 reg
// ddr_RRESP                      I     2 reg
// ddr_RLAST                      I     1 reg
// open_AWREADY                   I     1
// open_WREADY                    I     1
// open_BVALID                    I     1
// open_BID                       I     1 reg
// open_BRESP                     I     2 reg
// open_ARREADY                   I     1
// open_RVALID                    I     1
// open_RID                       I     1 reg
// open_RDATA                     I    64 reg
// open_RRESP                     I     2 reg
// open_RLAST                     I     1 reg
// wire_tms_tms_in                I     1
// wire_tdi_tdi_in                I     1
// qspi_io_io_i_io_i              I     4
// EN_io_dump_get                 I     1
//
// No combinational paths from inputs to outputs
//
//
`include"mkriscv_debug.v"
`include"ResetEither.v"
`include"mkjtagdtm.v"
`include"MakeReset0.v"
`include"mkSoc.v"
`include"SyncFIFO1.v"



`ifdef BSV_ASSIGNMENT_DELAY
`else
  `define BSV_ASSIGNMENT_DELAY
`endif

`ifdef BSV_POSITIVE_RESET
  `define BSV_RESET_VALUE 1'b1
  `define BSV_RESET_EDGE posedge
`else
  `define BSV_RESET_VALUE 1'b0
  `define BSV_RESET_EDGE negedge
`endif

module mkDebugSoc(CLK_tck_clk,
		  RST_N_trst,
		  CLK,
		  RST_N,

		  uart0_SIN,

		  uart0_SOUT,

		  boot_config,

		  gpio_in_val,

		  gpio_in_en,

		  gpio_out_val,

		  gpio_out_en,

		  gpio_pullup_en,

		  gpio_drive_0,

		  gpio_drive_1,

		  gpio_drive_2,

		  ddr_AWVALID,

		  ddr_AWID,

		  ddr_AWADDR,

		  ddr_AWLEN,

		  ddr_AWSIZE,

		  ddr_AWBURST,

		  ddr_AWLOCK,

		  ddr_AWCACHE,

		  ddr_AWPROT,

		  ddr_AWQOS,

		  ddr_AWREGION,

		  ddr_AWREADY,

		  ddr_WVALID,

		  ddr_WDATA,

		  ddr_WSTRB,

		  ddr_WLAST,

		  ddr_WREADY,

		  ddr_BVALID,
		  ddr_BID,
		  ddr_BRESP,

		  ddr_BREADY,

		  ddr_ARVALID,

		  ddr_ARID,

		  ddr_ARADDR,

		  ddr_ARLEN,

		  ddr_ARSIZE,

		  ddr_ARBURST,

		  ddr_ARLOCK,

		  ddr_ARCACHE,

		  ddr_ARPROT,

		  ddr_ARQOS,

		  ddr_ARREGION,

		  ddr_ARREADY,

		  ddr_RVALID,
		  ddr_RID,
		  ddr_RDATA,
		  ddr_RRESP,
		  ddr_RLAST,

		  ddr_RREADY,

		  open_AWVALID,

		  open_AWID,

		  open_AWADDR,

		  open_AWLEN,

		  open_AWSIZE,

		  open_AWBURST,

		  open_AWLOCK,

		  open_AWCACHE,

		  open_AWPROT,

		  open_AWQOS,

		  open_AWREGION,

		  open_AWREADY,

		  open_WVALID,

		  open_WDATA,

		  open_WSTRB,

		  open_WLAST,

		  open_WREADY,

		  open_BVALID,
		  open_BID,
		  open_BRESP,

		  open_BREADY,

		  open_ARVALID,

		  open_ARID,

		  open_ARADDR,

		  open_ARLEN,

		  open_ARSIZE,

		  open_ARBURST,

		  open_ARLOCK,

		  open_ARCACHE,

		  open_ARPROT,

		  open_ARQOS,

		  open_ARREGION,

		  open_ARREADY,

		  open_RVALID,
		  open_RID,
		  open_RDATA,
		  open_RRESP,
		  open_RLAST,

		  open_RREADY,

		  wire_tms_tms_in,

		  wire_tdi_tdi_in,

		  wire_tdo,

		  EN_io_dump_get,
		  io_dump_get,
		  RDY_io_dump_get,

		  qspi_io_clk_o,

		  qspi_io_io_o,

		  qspi_io_io_enable,

		  qspi_io_io_i_io_i,

		  qspi_io_ncs_o,

		  RST_N_soc_reset);
  input  CLK_tck_clk;
  input  RST_N_trst;
  input  CLK;
  input  RST_N;

  // action method ifc_uart0_sin
  input  uart0_SIN;

  // value method ifc_uart0_sout
  output uart0_SOUT;

  // action method boot_config
  input  [1 : 0] boot_config;

  // action method ifc_gpio_gpio_in_val
  input  [21 : 0] gpio_in_val;

  // value method ifc_gpio_gpio_in_en
  output [21 : 0] gpio_in_en;

  // value method ifc_gpio_gpio_out_val
  output [21 : 0] gpio_out_val;

  // value method ifc_gpio_gpio_out_en
  output [21 : 0] gpio_out_en;

  // value method ifc_gpio_gpio_pullup_en
  output [21 : 0] gpio_pullup_en;

  // value method ifc_gpio_gpio_drive_0
  output [21 : 0] gpio_drive_0;

  // value method ifc_gpio_gpio_drive_1
  output [21 : 0] gpio_drive_1;

  // value method ifc_gpio_gpio_drive_2
  output [21 : 0] gpio_drive_2;

  // value method ddr_slave_m_awvalid
  output ddr_AWVALID;

  // value method ddr_slave_m_awid
  output ddr_AWID;

  // value method ddr_slave_m_awaddr
  output [31 : 0] ddr_AWADDR;

  // value method ddr_slave_m_awlen
  output [7 : 0] ddr_AWLEN;

  // value method ddr_slave_m_awsize
  output [2 : 0] ddr_AWSIZE;

  // value method ddr_slave_m_awburst
  output [1 : 0] ddr_AWBURST;

  // value method ddr_slave_m_awlock
  output ddr_AWLOCK;

  // value method ddr_slave_m_awcache
  output [3 : 0] ddr_AWCACHE;

  // value method ddr_slave_m_awprot
  output [2 : 0] ddr_AWPROT;

  // value method ddr_slave_m_awqos
  output [3 : 0] ddr_AWQOS;

  // value method ddr_slave_m_awregion
  output [3 : 0] ddr_AWREGION;

  // value method ddr_slave_m_awuser

  // action method ddr_slave_m_awready
  input  ddr_AWREADY;

  // value method ddr_slave_m_wvalid
  output ddr_WVALID;

  // value method ddr_slave_m_wdata
  output [63 : 0] ddr_WDATA;

  // value method ddr_slave_m_wstrb
  output [7 : 0] ddr_WSTRB;

  // value method ddr_slave_m_wlast
  output ddr_WLAST;

  // value method ddr_slave_m_wuser

  // action method ddr_slave_m_wready
  input  ddr_WREADY;

  // action method ddr_slave_m_bvalid
  input  ddr_BVALID;
  input  ddr_BID;
  input  [1 : 0] ddr_BRESP;

  // value method ddr_slave_m_bready
  output ddr_BREADY;

  // value method ddr_slave_m_arvalid
  output ddr_ARVALID;

  // value method ddr_slave_m_arid
  output ddr_ARID;

  // value method ddr_slave_m_araddr
  output [31 : 0] ddr_ARADDR;

  // value method ddr_slave_m_arlen
  output [7 : 0] ddr_ARLEN;

  // value method ddr_slave_m_arsize
  output [2 : 0] ddr_ARSIZE;

  // value method ddr_slave_m_arburst
  output [1 : 0] ddr_ARBURST;

  // value method ddr_slave_m_arlock
  output ddr_ARLOCK;

  // value method ddr_slave_m_arcache
  output [3 : 0] ddr_ARCACHE;

  // value method ddr_slave_m_arprot
  output [2 : 0] ddr_ARPROT;

  // value method ddr_slave_m_arqos
  output [3 : 0] ddr_ARQOS;

  // value method ddr_slave_m_arregion
  output [3 : 0] ddr_ARREGION;

  // value method ddr_slave_m_aruser

  // action method ddr_slave_m_arready
  input  ddr_ARREADY;

  // action method ddr_slave_m_rvalid
  input  ddr_RVALID;
  input  ddr_RID;
  input  [63 : 0] ddr_RDATA;
  input  [1 : 0] ddr_RRESP;
  input  ddr_RLAST;

  // value method ddr_slave_m_rready
  output ddr_RREADY;

  // value method open_slave_m_awvalid
  output open_AWVALID;

  // value method open_slave_m_awid
  output open_AWID;

  // value method open_slave_m_awaddr
  output [31 : 0] open_AWADDR;

  // value method open_slave_m_awlen
  output [7 : 0] open_AWLEN;

  // value method open_slave_m_awsize
  output [2 : 0] open_AWSIZE;

  // value method open_slave_m_awburst
  output [1 : 0] open_AWBURST;

  // value method open_slave_m_awlock
  output open_AWLOCK;

  // value method open_slave_m_awcache
  output [3 : 0] open_AWCACHE;

  // value method open_slave_m_awprot
  output [2 : 0] open_AWPROT;

  // value method open_slave_m_awqos
  output [3 : 0] open_AWQOS;

  // value method open_slave_m_awregion
  output [3 : 0] open_AWREGION;

  // value method open_slave_m_awuser

  // action method open_slave_m_awready
  input  open_AWREADY;

  // value method open_slave_m_wvalid
  output open_WVALID;

  // value method open_slave_m_wdata
  output [63 : 0] open_WDATA;

  // value method open_slave_m_wstrb
  output [7 : 0] open_WSTRB;

  // value method open_slave_m_wlast
  output open_WLAST;

  // value method open_slave_m_wuser

  // action method open_slave_m_wready
  input  open_WREADY;

  // action method open_slave_m_bvalid
  input  open_BVALID;
  input  open_BID;
  input  [1 : 0] open_BRESP;

  // value method open_slave_m_bready
  output open_BREADY;

  // value method open_slave_m_arvalid
  output open_ARVALID;

  // value method open_slave_m_arid
  output open_ARID;

  // value method open_slave_m_araddr
  output [31 : 0] open_ARADDR;

  // value method open_slave_m_arlen
  output [7 : 0] open_ARLEN;

  // value method open_slave_m_arsize
  output [2 : 0] open_ARSIZE;

  // value method open_slave_m_arburst
  output [1 : 0] open_ARBURST;

  // value method open_slave_m_arlock
  output open_ARLOCK;

  // value method open_slave_m_arcache
  output [3 : 0] open_ARCACHE;

  // value method open_slave_m_arprot
  output [2 : 0] open_ARPROT;

  // value method open_slave_m_arqos
  output [3 : 0] open_ARQOS;

  // value method open_slave_m_arregion
  output [3 : 0] open_ARREGION;

  // value method open_slave_m_aruser

  // action method open_slave_m_arready
  input  open_ARREADY;

  // action method open_slave_m_rvalid
  input  open_RVALID;
  input  open_RID;
  input  [63 : 0] open_RDATA;
  input  [1 : 0] open_RRESP;
  input  open_RLAST;

  // value method open_slave_m_rready
  output open_RREADY;

  // action method wire_tms
  input  wire_tms_tms_in;

  // action method wire_tdi
  input  wire_tdi_tdi_in;

  // value method wire_tdo
  output wire_tdo;

  // actionvalue method io_dump_get
  input  EN_io_dump_get;
  output [167 : 0] io_dump_get;
  output RDY_io_dump_get;

  // value method qspi_io_clk_o
  output qspi_io_clk_o;

  // value method qspi_io_io_o
  output [3 : 0] qspi_io_io_o;

  // value method qspi_io_io_enable
  output [3 : 0] qspi_io_io_enable;

  // action method qspi_io_io_i
  input  [3 : 0] qspi_io_io_i_io_i;

  // value method qspi_io_ncs_o
  output qspi_io_ncs_o;

  // output resets
  output RST_N_soc_reset;

  // signals for module outputs
  wire [167 : 0] io_dump_get;
  wire [63 : 0] ddr_WDATA, open_WDATA;
  wire [31 : 0] ddr_ARADDR, ddr_AWADDR, open_ARADDR, open_AWADDR;
  wire [21 : 0] gpio_drive_0,
		gpio_drive_1,
		gpio_drive_2,
		gpio_in_en,
		gpio_out_en,
		gpio_out_val,
		gpio_pullup_en;
  wire [7 : 0] ddr_ARLEN,
	       ddr_AWLEN,
	       ddr_WSTRB,
	       open_ARLEN,
	       open_AWLEN,
	       open_WSTRB;
  wire [3 : 0] ddr_ARCACHE,
	       ddr_ARQOS,
	       ddr_ARREGION,
	       ddr_AWCACHE,
	       ddr_AWQOS,
	       ddr_AWREGION,
	       open_ARCACHE,
	       open_ARQOS,
	       open_ARREGION,
	       open_AWCACHE,
	       open_AWQOS,
	       open_AWREGION,
	       qspi_io_io_enable,
	       qspi_io_io_o;
  wire [2 : 0] ddr_ARPROT,
	       ddr_ARSIZE,
	       ddr_AWPROT,
	       ddr_AWSIZE,
	       open_ARPROT,
	       open_ARSIZE,
	       open_AWPROT,
	       open_AWSIZE;
  wire [1 : 0] ddr_ARBURST, ddr_AWBURST, open_ARBURST, open_AWBURST;
  wire RDY_io_dump_get,
       RST_N_soc_reset,
       ddr_ARID,
       ddr_ARLOCK,
       ddr_ARVALID,
       ddr_AWID,
       ddr_AWLOCK,
       ddr_AWVALID,
       ddr_BREADY,
       ddr_RREADY,
       ddr_WLAST,
       ddr_WVALID,
       open_ARID,
       open_ARLOCK,
       open_ARVALID,
       open_AWID,
       open_AWLOCK,
       open_AWVALID,
       open_BREADY,
       open_RREADY,
       open_WLAST,
       open_WVALID,
       qspi_io_clk_o,
       qspi_io_ncs_o,
       uart0_SOUT,
       wire_tdo;

  // register tdi
  reg tdi;
  wire tdi_D_IN, tdi_EN;

  // register tdo
  reg tdo;
  wire tdo_D_IN, tdo_EN;

  // register tms
  reg tms;
  wire tms_D_IN, tms_EN;

  // ports of submodule debug_module
  wire [78 : 0] debug_module_hart_abstractOperation;
  wire [63 : 0] debug_module_debug_master_RDATA,
		debug_module_debug_master_WDATA,
		debug_module_hart_abstractReadResponse_abstractResponse;
  wire [40 : 0] debug_module_dtm_putCommand_put;
  wire [33 : 0] debug_module_dtm_getResponse_get;
  wire [31 : 0] debug_module_debug_master_ARADDR,
		debug_module_debug_master_AWADDR;
  wire [7 : 0] debug_module_debug_master_ARLEN,
	       debug_module_debug_master_AWLEN,
	       debug_module_debug_master_WSTRB;
  wire [3 : 0] debug_module_debug_master_ARCACHE,
	       debug_module_debug_master_ARQOS,
	       debug_module_debug_master_ARREGION,
	       debug_module_debug_master_AWCACHE,
	       debug_module_debug_master_AWQOS,
	       debug_module_debug_master_AWREGION;
  wire [2 : 0] debug_module_debug_master_ARPROT,
	       debug_module_debug_master_ARSIZE,
	       debug_module_debug_master_AWPROT,
	       debug_module_debug_master_AWSIZE;
  wire [1 : 0] debug_module_debug_master_ARBURST,
	       debug_module_debug_master_AWBURST,
	       debug_module_debug_master_BRESP,
	       debug_module_debug_master_RRESP;
  wire debug_module_EN_dtm_getResponse_get,
       debug_module_EN_dtm_putCommand_put,
       debug_module_EN_hart_abstractOperation,
       debug_module_EN_hart_abstractReadResponse,
       debug_module_RDY_dtm_getResponse_get,
       debug_module_RDY_dtm_putCommand_put,
       debug_module_RDY_hart_abstractOperation,
       debug_module_RDY_hart_abstractReadResponse,
       debug_module_RST_N_dmactive_reset,
       debug_module_debug_master_ARID,
       debug_module_debug_master_ARLOCK,
       debug_module_debug_master_ARREADY,
       debug_module_debug_master_ARVALID,
       debug_module_debug_master_AWID,
       debug_module_debug_master_AWLOCK,
       debug_module_debug_master_AWREADY,
       debug_module_debug_master_AWVALID,
       debug_module_debug_master_BID,
       debug_module_debug_master_BREADY,
       debug_module_debug_master_BVALID,
       debug_module_debug_master_RID,
       debug_module_debug_master_RLAST,
       debug_module_debug_master_RREADY,
       debug_module_debug_master_RVALID,
       debug_module_debug_master_WLAST,
       debug_module_debug_master_WREADY,
       debug_module_debug_master_WVALID,
       debug_module_getNDMReset,
       debug_module_hart_dm_active,
       debug_module_hart_haltRequest,
       debug_module_hart_hart_reset,
       debug_module_hart_resumeRequest,
       debug_module_hart_set_halted_halted,
       debug_module_hart_set_have_reset_have_reset,
       debug_module_hart_set_unavailable_unavailable;

  // ports of submodule derived_reset
  wire derived_reset_RST_OUT;

  // ports of submodule jtag_tap
  wire [39 : 0] jtag_tap_request_to_dm;
  wire [33 : 0] jtag_tap_response_from_dm_responsedm;
  wire jtag_tap_EN_bs_chain_i,
       jtag_tap_EN_debug_tdi_i,
       jtag_tap_EN_request_to_dm,
       jtag_tap_EN_response_from_dm,
       jtag_tap_RDY_request_to_dm,
       jtag_tap_RDY_response_from_dm,
       jtag_tap_bs_chain_i_bs_chain,
       jtag_tap_debug_tdi_i_debug_tdi,
       jtag_tap_tdi_i_tdi,
       jtag_tap_tdo,
       jtag_tap_tms_i_tms;

  // ports of submodule ndm_reset
  wire ndm_reset_ASSERT_IN, ndm_reset_OUT_RST;

  // ports of submodule soc
  wire [167 : 0] soc_io_dump_get;
  wire [78 : 0] soc_debug_server_abstractOperation_cmd;
  wire [63 : 0] soc_ddr_RDATA,
		soc_ddr_WDATA,
		soc_debug_master_RDATA,
		soc_debug_master_WDATA,
		soc_debug_server_abstractReadResponse,
		soc_open_RDATA,
		soc_open_WDATA;
  wire [31 : 0] soc_ddr_ARADDR,
		soc_ddr_AWADDR,
		soc_debug_master_ARADDR,
		soc_debug_master_AWADDR,
		soc_open_ARADDR,
		soc_open_AWADDR;
  wire [21 : 0] soc_gpio_drive_0,
		soc_gpio_drive_1,
		soc_gpio_drive_2,
		soc_gpio_in_en,
		soc_gpio_in_val,
		soc_gpio_out_en,
		soc_gpio_out_val,
		soc_gpio_pullup_en;
  wire [7 : 0] soc_ddr_ARLEN,
	       soc_ddr_AWLEN,
	       soc_ddr_WSTRB,
	       soc_debug_master_ARLEN,
	       soc_debug_master_AWLEN,
	       soc_debug_master_WSTRB,
	       soc_open_ARLEN,
	       soc_open_AWLEN,
	       soc_open_WSTRB;
  wire [3 : 0] soc_ddr_ARCACHE,
	       soc_ddr_ARQOS,
	       soc_ddr_ARREGION,
	       soc_ddr_AWCACHE,
	       soc_ddr_AWQOS,
	       soc_ddr_AWREGION,
	       soc_debug_master_ARCACHE,
	       soc_debug_master_ARQOS,
	       soc_debug_master_ARREGION,
	       soc_debug_master_AWCACHE,
	       soc_debug_master_AWQOS,
	       soc_debug_master_AWREGION,
	       soc_open_ARCACHE,
	       soc_open_ARQOS,
	       soc_open_ARREGION,
	       soc_open_AWCACHE,
	       soc_open_AWQOS,
	       soc_open_AWREGION,
	       soc_qspi_io_io_enable,
	       soc_qspi_io_io_i_io_i,
	       soc_qspi_io_io_o;
  wire [2 : 0] soc_ddr_ARPROT,
	       soc_ddr_ARSIZE,
	       soc_ddr_AWPROT,
	       soc_ddr_AWSIZE,
	       soc_debug_master_ARPROT,
	       soc_debug_master_ARSIZE,
	       soc_debug_master_AWPROT,
	       soc_debug_master_AWSIZE,
	       soc_open_ARPROT,
	       soc_open_ARSIZE,
	       soc_open_AWPROT,
	       soc_open_AWSIZE;
  wire [1 : 0] soc_boot_config,
	       soc_ddr_ARBURST,
	       soc_ddr_AWBURST,
	       soc_ddr_BRESP,
	       soc_ddr_RRESP,
	       soc_debug_master_ARBURST,
	       soc_debug_master_AWBURST,
	       soc_debug_master_BRESP,
	       soc_debug_master_RRESP,
	       soc_open_ARBURST,
	       soc_open_AWBURST,
	       soc_open_BRESP,
	       soc_open_RRESP;
  wire soc_EN_debug_server_abstractOperation,
       soc_EN_debug_server_abstractReadResponse,
       soc_EN_io_dump_get,
       soc_RDY_debug_server_abstractOperation,
       soc_RDY_debug_server_abstractReadResponse,
       soc_RDY_io_dump_get,
       soc_ddr_ARID,
       soc_ddr_ARLOCK,
       soc_ddr_ARREADY,
       soc_ddr_ARVALID,
       soc_ddr_AWID,
       soc_ddr_AWLOCK,
       soc_ddr_AWREADY,
       soc_ddr_AWVALID,
       soc_ddr_BID,
       soc_ddr_BREADY,
       soc_ddr_BVALID,
       soc_ddr_RID,
       soc_ddr_RLAST,
       soc_ddr_RREADY,
       soc_ddr_RVALID,
       soc_ddr_WLAST,
       soc_ddr_WREADY,
       soc_ddr_WVALID,
       soc_debug_master_ARID,
       soc_debug_master_ARLOCK,
       soc_debug_master_ARREADY,
       soc_debug_master_ARVALID,
       soc_debug_master_AWID,
       soc_debug_master_AWLOCK,
       soc_debug_master_AWREADY,
       soc_debug_master_AWVALID,
       soc_debug_master_BID,
       soc_debug_master_BREADY,
       soc_debug_master_BVALID,
       soc_debug_master_RID,
       soc_debug_master_RLAST,
       soc_debug_master_RREADY,
       soc_debug_master_RVALID,
       soc_debug_master_WLAST,
       soc_debug_master_WREADY,
       soc_debug_master_WVALID,
       soc_debug_server_dm_active_dm_active,
       soc_debug_server_haltRequest_halt_request,
       soc_debug_server_hartReset_hart_reset_v,
       soc_debug_server_has_reset,
       soc_debug_server_is_halted,
       soc_debug_server_is_unavailable,
       soc_debug_server_resumeRequest_resume_request,
       soc_open_ARID,
       soc_open_ARLOCK,
       soc_open_ARREADY,
       soc_open_ARVALID,
       soc_open_AWID,
       soc_open_AWLOCK,
       soc_open_AWREADY,
       soc_open_AWVALID,
       soc_open_BID,
       soc_open_BREADY,
       soc_open_BVALID,
       soc_open_RID,
       soc_open_RLAST,
       soc_open_RREADY,
       soc_open_RVALID,
       soc_open_WLAST,
       soc_open_WREADY,
       soc_open_WVALID,
       soc_qspi_io_clk_o,
       soc_qspi_io_ncs_o,
       soc_uart0_SIN,
       soc_uart0_SOUT;

  // ports of submodule sync_request_to_dm
  wire [40 : 0] sync_request_to_dm_dD_OUT, sync_request_to_dm_sD_IN;
  wire sync_request_to_dm_dDEQ,
       sync_request_to_dm_dEMPTY_N,
       sync_request_to_dm_sENQ,
       sync_request_to_dm_sFULL_N;

  // ports of submodule sync_response_from_dm
  wire [33 : 0] sync_response_from_dm_dD_OUT, sync_response_from_dm_sD_IN;
  wire sync_response_from_dm_dDEQ,
       sync_response_from_dm_dEMPTY_N,
       sync_response_from_dm_sENQ,
       sync_response_from_dm_sFULL_N;

  // rule scheduling signals
  wire CAN_FIRE_RL_assign_jtag_inputs,
       CAN_FIRE_RL_assign_jtag_output,
       CAN_FIRE_RL_connect_available,
       CAN_FIRE_RL_connect_debug_response_to_syncfifo,
       CAN_FIRE_RL_connect_dm_active,
       CAN_FIRE_RL_connect_halt_req,
       CAN_FIRE_RL_connect_halted,
       CAN_FIRE_RL_connect_hart_reset,
       CAN_FIRE_RL_connect_has_reset,
       CAN_FIRE_RL_connect_resume_req,
       CAN_FIRE_RL_connect_tap_request_to_syncfifo,
       CAN_FIRE_RL_operation,
       CAN_FIRE_RL_read_synced_request_to_dm,
       CAN_FIRE_RL_read_synced_response_from_dm,
       CAN_FIRE_RL_response,
       CAN_FIRE_RL_rl_generate_ndmreset,
       CAN_FIRE_RL_rl_rd_addr_channel,
       CAN_FIRE_RL_rl_rd_data_channel,
       CAN_FIRE_RL_rl_wr_addr_channel,
       CAN_FIRE_RL_rl_wr_data_channel,
       CAN_FIRE_RL_rl_wr_response_channel,
       CAN_FIRE_boot_config,
       CAN_FIRE_ddr_slave_m_arready,
       CAN_FIRE_ddr_slave_m_awready,
       CAN_FIRE_ddr_slave_m_bvalid,
       CAN_FIRE_ddr_slave_m_rvalid,
       CAN_FIRE_ddr_slave_m_wready,
       CAN_FIRE_ifc_gpio_gpio_in_val,
       CAN_FIRE_ifc_uart0_sin,
       CAN_FIRE_io_dump_get,
       CAN_FIRE_open_slave_m_arready,
       CAN_FIRE_open_slave_m_awready,
       CAN_FIRE_open_slave_m_bvalid,
       CAN_FIRE_open_slave_m_rvalid,
       CAN_FIRE_open_slave_m_wready,
       CAN_FIRE_qspi_io_io_i,
       CAN_FIRE_wire_tdi,
       CAN_FIRE_wire_tms,
       WILL_FIRE_RL_assign_jtag_inputs,
       WILL_FIRE_RL_assign_jtag_output,
       WILL_FIRE_RL_connect_available,
       WILL_FIRE_RL_connect_debug_response_to_syncfifo,
       WILL_FIRE_RL_connect_dm_active,
       WILL_FIRE_RL_connect_halt_req,
       WILL_FIRE_RL_connect_halted,
       WILL_FIRE_RL_connect_hart_reset,
       WILL_FIRE_RL_connect_has_reset,
       WILL_FIRE_RL_connect_resume_req,
       WILL_FIRE_RL_connect_tap_request_to_syncfifo,
       WILL_FIRE_RL_operation,
       WILL_FIRE_RL_read_synced_request_to_dm,
       WILL_FIRE_RL_read_synced_response_from_dm,
       WILL_FIRE_RL_response,
       WILL_FIRE_RL_rl_generate_ndmreset,
       WILL_FIRE_RL_rl_rd_addr_channel,
       WILL_FIRE_RL_rl_rd_data_channel,
       WILL_FIRE_RL_rl_wr_addr_channel,
       WILL_FIRE_RL_rl_wr_data_channel,
       WILL_FIRE_RL_rl_wr_response_channel,
       WILL_FIRE_boot_config,
       WILL_FIRE_ddr_slave_m_arready,
       WILL_FIRE_ddr_slave_m_awready,
       WILL_FIRE_ddr_slave_m_bvalid,
       WILL_FIRE_ddr_slave_m_rvalid,
       WILL_FIRE_ddr_slave_m_wready,
       WILL_FIRE_ifc_gpio_gpio_in_val,
       WILL_FIRE_ifc_uart0_sin,
       WILL_FIRE_io_dump_get,
       WILL_FIRE_open_slave_m_arready,
       WILL_FIRE_open_slave_m_awready,
       WILL_FIRE_open_slave_m_bvalid,
       WILL_FIRE_open_slave_m_rvalid,
       WILL_FIRE_open_slave_m_wready,
       WILL_FIRE_qspi_io_io_i,
       WILL_FIRE_wire_tdi,
       WILL_FIRE_wire_tms;

  // declarations used by system tasks
  // synopsys translate_off
  reg TASK_testplusargs___d64;
  reg TASK_testplusargs___d65;
  reg TASK_testplusargs___d66;
  reg [63 : 0] v__h3325;
  // synopsys translate_on

  // output resets
  assign RST_N_soc_reset = derived_reset_RST_OUT ;

  // action method ifc_uart0_sin
  assign CAN_FIRE_ifc_uart0_sin = 1'd1 ;
  assign WILL_FIRE_ifc_uart0_sin = 1'd1 ;

  // value method ifc_uart0_sout
  assign uart0_SOUT = soc_uart0_SOUT ;

  // action method boot_config
  assign CAN_FIRE_boot_config = 1'd1 ;
  assign WILL_FIRE_boot_config = 1'd1 ;

  // action method ifc_gpio_gpio_in_val
  assign CAN_FIRE_ifc_gpio_gpio_in_val = 1'd1 ;
  assign WILL_FIRE_ifc_gpio_gpio_in_val = 1'd1 ;

  // value method ifc_gpio_gpio_in_en
  assign gpio_in_en = soc_gpio_in_en ;

  // value method ifc_gpio_gpio_out_val
  assign gpio_out_val = soc_gpio_out_val ;

  // value method ifc_gpio_gpio_out_en
  assign gpio_out_en = soc_gpio_out_en ;

  // value method ifc_gpio_gpio_pullup_en
  assign gpio_pullup_en = soc_gpio_pullup_en ;

  // value method ifc_gpio_gpio_drive_0
  assign gpio_drive_0 = soc_gpio_drive_0 ;

  // value method ifc_gpio_gpio_drive_1
  assign gpio_drive_1 = soc_gpio_drive_1 ;

  // value method ifc_gpio_gpio_drive_2
  assign gpio_drive_2 = soc_gpio_drive_2 ;

  // value method ddr_slave_m_awvalid
  assign ddr_AWVALID = soc_ddr_AWVALID ;

  // value method ddr_slave_m_awid
  assign ddr_AWID = soc_ddr_AWID ;

  // value method ddr_slave_m_awaddr
  assign ddr_AWADDR = soc_ddr_AWADDR ;

  // value method ddr_slave_m_awlen
  assign ddr_AWLEN = soc_ddr_AWLEN ;

  // value method ddr_slave_m_awsize
  assign ddr_AWSIZE = soc_ddr_AWSIZE ;

  // value method ddr_slave_m_awburst
  assign ddr_AWBURST = soc_ddr_AWBURST ;

  // value method ddr_slave_m_awlock
  assign ddr_AWLOCK = soc_ddr_AWLOCK ;

  // value method ddr_slave_m_awcache
  assign ddr_AWCACHE = soc_ddr_AWCACHE ;

  // value method ddr_slave_m_awprot
  assign ddr_AWPROT = soc_ddr_AWPROT ;

  // value method ddr_slave_m_awqos
  assign ddr_AWQOS = soc_ddr_AWQOS ;

  // value method ddr_slave_m_awregion
  assign ddr_AWREGION = soc_ddr_AWREGION ;

  // action method ddr_slave_m_awready
  assign CAN_FIRE_ddr_slave_m_awready = 1'd1 ;
  assign WILL_FIRE_ddr_slave_m_awready = 1'd1 ;

  // value method ddr_slave_m_wvalid
  assign ddr_WVALID = soc_ddr_WVALID ;

  // value method ddr_slave_m_wdata
  assign ddr_WDATA = soc_ddr_WDATA ;

  // value method ddr_slave_m_wstrb
  assign ddr_WSTRB = soc_ddr_WSTRB ;

  // value method ddr_slave_m_wlast
  assign ddr_WLAST = soc_ddr_WLAST ;

  // action method ddr_slave_m_wready
  assign CAN_FIRE_ddr_slave_m_wready = 1'd1 ;
  assign WILL_FIRE_ddr_slave_m_wready = 1'd1 ;

  // action method ddr_slave_m_bvalid
  assign CAN_FIRE_ddr_slave_m_bvalid = 1'd1 ;
  assign WILL_FIRE_ddr_slave_m_bvalid = 1'd1 ;

  // value method ddr_slave_m_bready
  assign ddr_BREADY = soc_ddr_BREADY ;

  // value method ddr_slave_m_arvalid
  assign ddr_ARVALID = soc_ddr_ARVALID ;

  // value method ddr_slave_m_arid
  assign ddr_ARID = soc_ddr_ARID ;

  // value method ddr_slave_m_araddr
  assign ddr_ARADDR = soc_ddr_ARADDR ;

  // value method ddr_slave_m_arlen
  assign ddr_ARLEN = soc_ddr_ARLEN ;

  // value method ddr_slave_m_arsize
  assign ddr_ARSIZE = soc_ddr_ARSIZE ;

  // value method ddr_slave_m_arburst
  assign ddr_ARBURST = soc_ddr_ARBURST ;

  // value method ddr_slave_m_arlock
  assign ddr_ARLOCK = soc_ddr_ARLOCK ;

  // value method ddr_slave_m_arcache
  assign ddr_ARCACHE = soc_ddr_ARCACHE ;

  // value method ddr_slave_m_arprot
  assign ddr_ARPROT = soc_ddr_ARPROT ;

  // value method ddr_slave_m_arqos
  assign ddr_ARQOS = soc_ddr_ARQOS ;

  // value method ddr_slave_m_arregion
  assign ddr_ARREGION = soc_ddr_ARREGION ;

  // action method ddr_slave_m_arready
  assign CAN_FIRE_ddr_slave_m_arready = 1'd1 ;
  assign WILL_FIRE_ddr_slave_m_arready = 1'd1 ;

  // action method ddr_slave_m_rvalid
  assign CAN_FIRE_ddr_slave_m_rvalid = 1'd1 ;
  assign WILL_FIRE_ddr_slave_m_rvalid = 1'd1 ;

  // value method ddr_slave_m_rready
  assign ddr_RREADY = soc_ddr_RREADY ;

  // value method open_slave_m_awvalid
  assign open_AWVALID = soc_open_AWVALID ;

  // value method open_slave_m_awid
  assign open_AWID = soc_open_AWID ;

  // value method open_slave_m_awaddr
  assign open_AWADDR = soc_open_AWADDR ;

  // value method open_slave_m_awlen
  assign open_AWLEN = soc_open_AWLEN ;

  // value method open_slave_m_awsize
  assign open_AWSIZE = soc_open_AWSIZE ;

  // value method open_slave_m_awburst
  assign open_AWBURST = soc_open_AWBURST ;

  // value method open_slave_m_awlock
  assign open_AWLOCK = soc_open_AWLOCK ;

  // value method open_slave_m_awcache
  assign open_AWCACHE = soc_open_AWCACHE ;

  // value method open_slave_m_awprot
  assign open_AWPROT = soc_open_AWPROT ;

  // value method open_slave_m_awqos
  assign open_AWQOS = soc_open_AWQOS ;

  // value method open_slave_m_awregion
  assign open_AWREGION = soc_open_AWREGION ;

  // action method open_slave_m_awready
  assign CAN_FIRE_open_slave_m_awready = 1'd1 ;
  assign WILL_FIRE_open_slave_m_awready = 1'd1 ;

  // value method open_slave_m_wvalid
  assign open_WVALID = soc_open_WVALID ;

  // value method open_slave_m_wdata
  assign open_WDATA = soc_open_WDATA ;

  // value method open_slave_m_wstrb
  assign open_WSTRB = soc_open_WSTRB ;

  // value method open_slave_m_wlast
  assign open_WLAST = soc_open_WLAST ;

  // action method open_slave_m_wready
  assign CAN_FIRE_open_slave_m_wready = 1'd1 ;
  assign WILL_FIRE_open_slave_m_wready = 1'd1 ;

  // action method open_slave_m_bvalid
  assign CAN_FIRE_open_slave_m_bvalid = 1'd1 ;
  assign WILL_FIRE_open_slave_m_bvalid = 1'd1 ;

  // value method open_slave_m_bready
  assign open_BREADY = soc_open_BREADY ;

  // value method open_slave_m_arvalid
  assign open_ARVALID = soc_open_ARVALID ;

  // value method open_slave_m_arid
  assign open_ARID = soc_open_ARID ;

  // value method open_slave_m_araddr
  assign open_ARADDR = soc_open_ARADDR ;

  // value method open_slave_m_arlen
  assign open_ARLEN = soc_open_ARLEN ;

  // value method open_slave_m_arsize
  assign open_ARSIZE = soc_open_ARSIZE ;

  // value method open_slave_m_arburst
  assign open_ARBURST = soc_open_ARBURST ;

  // value method open_slave_m_arlock
  assign open_ARLOCK = soc_open_ARLOCK ;

  // value method open_slave_m_arcache
  assign open_ARCACHE = soc_open_ARCACHE ;

  // value method open_slave_m_arprot
  assign open_ARPROT = soc_open_ARPROT ;

  // value method open_slave_m_arqos
  assign open_ARQOS = soc_open_ARQOS ;

  // value method open_slave_m_arregion
  assign open_ARREGION = soc_open_ARREGION ;

  // action method open_slave_m_arready
  assign CAN_FIRE_open_slave_m_arready = 1'd1 ;
  assign WILL_FIRE_open_slave_m_arready = 1'd1 ;

  // action method open_slave_m_rvalid
  assign CAN_FIRE_open_slave_m_rvalid = 1'd1 ;
  assign WILL_FIRE_open_slave_m_rvalid = 1'd1 ;

  // value method open_slave_m_rready
  assign open_RREADY = soc_open_RREADY ;

  // action method wire_tms
  assign CAN_FIRE_wire_tms = 1'd1 ;
  assign WILL_FIRE_wire_tms = 1'd1 ;

  // action method wire_tdi
  assign CAN_FIRE_wire_tdi = 1'd1 ;
  assign WILL_FIRE_wire_tdi = 1'd1 ;

  // value method wire_tdo
  assign wire_tdo = tdo ;

  // actionvalue method io_dump_get
  assign io_dump_get =
	     { (soc_io_dump_get[167:166] == 2'd3) ?
		 soc_io_dump_get[167:166] :
		 2'd0,
	       soc_io_dump_get[165:0] } ;
  assign RDY_io_dump_get = soc_RDY_io_dump_get ;
  assign CAN_FIRE_io_dump_get = soc_RDY_io_dump_get ;
  assign WILL_FIRE_io_dump_get = EN_io_dump_get ;

  // value method qspi_io_clk_o
  assign qspi_io_clk_o = soc_qspi_io_clk_o ;

  // value method qspi_io_io_o
  assign qspi_io_io_o = soc_qspi_io_io_o ;

  // value method qspi_io_io_enable
  assign qspi_io_io_enable = soc_qspi_io_io_enable ;

  // action method qspi_io_io_i
  assign CAN_FIRE_qspi_io_io_i = 1'd1 ;
  assign WILL_FIRE_qspi_io_io_i = 1'd1 ;

  // value method qspi_io_ncs_o
  assign qspi_io_ncs_o = soc_qspi_io_ncs_o ;

  // submodule debug_module
  mkriscv_debug debug_module(.CLK(CLK),
			     .RST_N(RST_N),
			     .debug_master_ARREADY(debug_module_debug_master_ARREADY),
			     .debug_master_AWREADY(debug_module_debug_master_AWREADY),
			     .debug_master_BID(debug_module_debug_master_BID),
			     .debug_master_BRESP(debug_module_debug_master_BRESP),
			     .debug_master_BVALID(debug_module_debug_master_BVALID),
			     .debug_master_RDATA(debug_module_debug_master_RDATA),
			     .debug_master_RID(debug_module_debug_master_RID),
			     .debug_master_RLAST(debug_module_debug_master_RLAST),
			     .debug_master_RRESP(debug_module_debug_master_RRESP),
			     .debug_master_RVALID(debug_module_debug_master_RVALID),
			     .debug_master_WREADY(debug_module_debug_master_WREADY),
			     .dtm_putCommand_put(debug_module_dtm_putCommand_put),
			     .hart_abstractReadResponse_abstractResponse(debug_module_hart_abstractReadResponse_abstractResponse),
			     .hart_set_halted_halted(debug_module_hart_set_halted_halted),
			     .hart_set_have_reset_have_reset(debug_module_hart_set_have_reset_have_reset),
			     .hart_set_unavailable_unavailable(debug_module_hart_set_unavailable_unavailable),
			     .EN_dtm_putCommand_put(debug_module_EN_dtm_putCommand_put),
			     .EN_dtm_getResponse_get(debug_module_EN_dtm_getResponse_get),
			     .EN_hart_abstractOperation(debug_module_EN_hart_abstractOperation),
			     .EN_hart_abstractReadResponse(debug_module_EN_hart_abstractReadResponse),
			     .RDY_dtm_putCommand_put(debug_module_RDY_dtm_putCommand_put),
			     .dtm_getResponse_get(debug_module_dtm_getResponse_get),
			     .RDY_dtm_getResponse_get(debug_module_RDY_dtm_getResponse_get),
			     .hart_abstractOperation(debug_module_hart_abstractOperation),
			     .RDY_hart_abstractOperation(debug_module_RDY_hart_abstractOperation),
			     .RDY_hart_abstractReadResponse(debug_module_RDY_hart_abstractReadResponse),
			     .hart_haltRequest(debug_module_hart_haltRequest),
			     .hart_resumeRequest(debug_module_hart_resumeRequest),
			     .hart_hart_reset(debug_module_hart_hart_reset),
			     .hart_dm_active(debug_module_hart_dm_active),
			     .debug_master_AWVALID(debug_module_debug_master_AWVALID),
			     .debug_master_AWID(debug_module_debug_master_AWID),
			     .debug_master_AWADDR(debug_module_debug_master_AWADDR),
			     .debug_master_AWLEN(debug_module_debug_master_AWLEN),
			     .debug_master_AWSIZE(debug_module_debug_master_AWSIZE),
			     .debug_master_AWBURST(debug_module_debug_master_AWBURST),
			     .debug_master_AWLOCK(debug_module_debug_master_AWLOCK),
			     .debug_master_AWCACHE(debug_module_debug_master_AWCACHE),
			     .debug_master_AWPROT(debug_module_debug_master_AWPROT),
			     .debug_master_AWQOS(debug_module_debug_master_AWQOS),
			     .debug_master_AWREGION(debug_module_debug_master_AWREGION),
			     .debug_master_WVALID(debug_module_debug_master_WVALID),
			     .debug_master_WDATA(debug_module_debug_master_WDATA),
			     .debug_master_WSTRB(debug_module_debug_master_WSTRB),
			     .debug_master_WLAST(debug_module_debug_master_WLAST),
			     .debug_master_BREADY(debug_module_debug_master_BREADY),
			     .debug_master_ARVALID(debug_module_debug_master_ARVALID),
			     .debug_master_ARID(debug_module_debug_master_ARID),
			     .debug_master_ARADDR(debug_module_debug_master_ARADDR),
			     .debug_master_ARLEN(debug_module_debug_master_ARLEN),
			     .debug_master_ARSIZE(debug_module_debug_master_ARSIZE),
			     .debug_master_ARBURST(debug_module_debug_master_ARBURST),
			     .debug_master_ARLOCK(debug_module_debug_master_ARLOCK),
			     .debug_master_ARCACHE(debug_module_debug_master_ARCACHE),
			     .debug_master_ARPROT(debug_module_debug_master_ARPROT),
			     .debug_master_ARQOS(debug_module_debug_master_ARQOS),
			     .debug_master_ARREGION(debug_module_debug_master_ARREGION),
			     .debug_master_RREADY(debug_module_debug_master_RREADY),
			     .getNDMReset(debug_module_getNDMReset),
			     .RDY_getNDMReset(),
			     .RST_N_dtm_dmactive_reset(),
			     .RST_N_dmactive_reset(debug_module_RST_N_dmactive_reset));

  // submodule derived_reset
  ResetEither derived_reset(.A_RST(ndm_reset_OUT_RST),
			    .B_RST(RST_N),
			    .RST_OUT(derived_reset_RST_OUT));

  // submodule jtag_tap
  mkjtagdtm jtag_tap(.CLK(CLK_tck_clk),
		     .RST_N(RST_N_trst),
		     .bs_chain_i_bs_chain(jtag_tap_bs_chain_i_bs_chain),
		     .debug_tdi_i_debug_tdi(jtag_tap_debug_tdi_i_debug_tdi),
		     .response_from_dm_responsedm(jtag_tap_response_from_dm_responsedm),
		     .tdi_i_tdi(jtag_tap_tdi_i_tdi),
		     .tms_i_tms(jtag_tap_tms_i_tms),
		     .EN_debug_tdi_i(jtag_tap_EN_debug_tdi_i),
		     .EN_bs_chain_i(jtag_tap_EN_bs_chain_i),
		     .EN_response_from_dm(jtag_tap_EN_response_from_dm),
		     .EN_request_to_dm(jtag_tap_EN_request_to_dm),
		     .RDY_debug_tdi_i(),
		     .RDY_bs_chain_i(),
		     .tdo(jtag_tap_tdo),
		     .tdo_oe(),
		     .RDY_tdo_oe(),
		     .shift_dr(),
		     .RDY_shift_dr(),
		     .pause_dr(),
		     .RDY_pause_dr(),
		     .update_dr(),
		     .RDY_update_dr(),
		     .capture_dr(),
		     .RDY_capture_dr(),
		     .extest_select(),
		     .RDY_extest_select(),
		     .sample_preload_select(),
		     .RDY_sample_preload_select(),
		     .debug_select(),
		     .RDY_debug_select(),
		     .debug_tdo(),
		     .RDY_debug_tdo(),
		     .RDY_response_from_dm(jtag_tap_RDY_response_from_dm),
		     .request_to_dm(jtag_tap_request_to_dm),
		     .RDY_request_to_dm(jtag_tap_RDY_request_to_dm));

  // submodule ndm_reset
  MakeReset0 #(.init(1'd1)) ndm_reset(.CLK(CLK),
				      .RST(RST_N),
				      .ASSERT_IN(ndm_reset_ASSERT_IN),
				      .ASSERT_OUT(),
				      .OUT_RST(ndm_reset_OUT_RST));

  // submodule soc
  mkSoc soc(.CLK(CLK),
	    .RST_N(derived_reset_RST_OUT),
	    .boot_config(soc_boot_config),
	    .ddr_ARREADY(soc_ddr_ARREADY),
	    .ddr_AWREADY(soc_ddr_AWREADY),
	    .ddr_BID(soc_ddr_BID),
	    .ddr_BRESP(soc_ddr_BRESP),
	    .ddr_BVALID(soc_ddr_BVALID),
	    .ddr_RDATA(soc_ddr_RDATA),
	    .ddr_RID(soc_ddr_RID),
	    .ddr_RLAST(soc_ddr_RLAST),
	    .ddr_RRESP(soc_ddr_RRESP),
	    .ddr_RVALID(soc_ddr_RVALID),
	    .ddr_WREADY(soc_ddr_WREADY),
	    .debug_master_ARADDR(soc_debug_master_ARADDR),
	    .debug_master_ARBURST(soc_debug_master_ARBURST),
	    .debug_master_ARCACHE(soc_debug_master_ARCACHE),
	    .debug_master_ARID(soc_debug_master_ARID),
	    .debug_master_ARLEN(soc_debug_master_ARLEN),
	    .debug_master_ARLOCK(soc_debug_master_ARLOCK),
	    .debug_master_ARPROT(soc_debug_master_ARPROT),
	    .debug_master_ARQOS(soc_debug_master_ARQOS),
	    .debug_master_ARREGION(soc_debug_master_ARREGION),
	    .debug_master_ARSIZE(soc_debug_master_ARSIZE),
	    .debug_master_ARVALID(soc_debug_master_ARVALID),
	    .debug_master_AWADDR(soc_debug_master_AWADDR),
	    .debug_master_AWBURST(soc_debug_master_AWBURST),
	    .debug_master_AWCACHE(soc_debug_master_AWCACHE),
	    .debug_master_AWID(soc_debug_master_AWID),
	    .debug_master_AWLEN(soc_debug_master_AWLEN),
	    .debug_master_AWLOCK(soc_debug_master_AWLOCK),
	    .debug_master_AWPROT(soc_debug_master_AWPROT),
	    .debug_master_AWQOS(soc_debug_master_AWQOS),
	    .debug_master_AWREGION(soc_debug_master_AWREGION),
	    .debug_master_AWSIZE(soc_debug_master_AWSIZE),
	    .debug_master_AWVALID(soc_debug_master_AWVALID),
	    .debug_master_BREADY(soc_debug_master_BREADY),
	    .debug_master_RREADY(soc_debug_master_RREADY),
	    .debug_master_WDATA(soc_debug_master_WDATA),
	    .debug_master_WLAST(soc_debug_master_WLAST),
	    .debug_master_WSTRB(soc_debug_master_WSTRB),
	    .debug_master_WVALID(soc_debug_master_WVALID),
	    .debug_server_abstractOperation_cmd(soc_debug_server_abstractOperation_cmd),
	    .debug_server_dm_active_dm_active(soc_debug_server_dm_active_dm_active),
	    .debug_server_haltRequest_halt_request(soc_debug_server_haltRequest_halt_request),
	    .debug_server_hartReset_hart_reset_v(soc_debug_server_hartReset_hart_reset_v),
	    .debug_server_resumeRequest_resume_request(soc_debug_server_resumeRequest_resume_request),
	    .gpio_in_val(soc_gpio_in_val),
	    .open_ARREADY(soc_open_ARREADY),
	    .open_AWREADY(soc_open_AWREADY),
	    .open_BID(soc_open_BID),
	    .open_BRESP(soc_open_BRESP),
	    .open_BVALID(soc_open_BVALID),
	    .open_RDATA(soc_open_RDATA),
	    .open_RID(soc_open_RID),
	    .open_RLAST(soc_open_RLAST),
	    .open_RRESP(soc_open_RRESP),
	    .open_RVALID(soc_open_RVALID),
	    .open_WREADY(soc_open_WREADY),
	    .qspi_io_io_i_io_i(soc_qspi_io_io_i_io_i),
	    .uart0_SIN(soc_uart0_SIN),
	    .EN_debug_server_abstractOperation(soc_EN_debug_server_abstractOperation),
	    .EN_debug_server_abstractReadResponse(soc_EN_debug_server_abstractReadResponse),
	    .EN_io_dump_get(soc_EN_io_dump_get),
	    .uart0_SOUT(soc_uart0_SOUT),
	    .gpio_in_en(soc_gpio_in_en),
	    .gpio_out_val(soc_gpio_out_val),
	    .gpio_out_en(soc_gpio_out_en),
	    .gpio_pullup_en(soc_gpio_pullup_en),
	    .gpio_drive_0(soc_gpio_drive_0),
	    .gpio_drive_1(soc_gpio_drive_1),
	    .gpio_drive_2(soc_gpio_drive_2),
	    .ddr_AWVALID(soc_ddr_AWVALID),
	    .ddr_AWID(soc_ddr_AWID),
	    .ddr_AWADDR(soc_ddr_AWADDR),
	    .ddr_AWLEN(soc_ddr_AWLEN),
	    .ddr_AWSIZE(soc_ddr_AWSIZE),
	    .ddr_AWBURST(soc_ddr_AWBURST),
	    .ddr_AWLOCK(soc_ddr_AWLOCK),
	    .ddr_AWCACHE(soc_ddr_AWCACHE),
	    .ddr_AWPROT(soc_ddr_AWPROT),
	    .ddr_AWQOS(soc_ddr_AWQOS),
	    .ddr_AWREGION(soc_ddr_AWREGION),
	    .ddr_WVALID(soc_ddr_WVALID),
	    .ddr_WDATA(soc_ddr_WDATA),
	    .ddr_WSTRB(soc_ddr_WSTRB),
	    .ddr_WLAST(soc_ddr_WLAST),
	    .ddr_BREADY(soc_ddr_BREADY),
	    .ddr_ARVALID(soc_ddr_ARVALID),
	    .ddr_ARID(soc_ddr_ARID),
	    .ddr_ARADDR(soc_ddr_ARADDR),
	    .ddr_ARLEN(soc_ddr_ARLEN),
	    .ddr_ARSIZE(soc_ddr_ARSIZE),
	    .ddr_ARBURST(soc_ddr_ARBURST),
	    .ddr_ARLOCK(soc_ddr_ARLOCK),
	    .ddr_ARCACHE(soc_ddr_ARCACHE),
	    .ddr_ARPROT(soc_ddr_ARPROT),
	    .ddr_ARQOS(soc_ddr_ARQOS),
	    .ddr_ARREGION(soc_ddr_ARREGION),
	    .ddr_RREADY(soc_ddr_RREADY),
	    //.open_AWVALID(soc_open_AWVALID),
	    .open_AWID(soc_open_AWID),
	    //.open_AWADDR(soc_open_AWADDR),
	    .open_AWLEN(soc_open_AWLEN),
	    .open_AWSIZE(soc_open_AWSIZE),
	    .open_AWBURST(soc_open_AWBURST),
	    .open_AWLOCK(soc_open_AWLOCK),
	    .open_AWCACHE(soc_open_AWCACHE),
	    //.open_AWPROT(soc_open_AWPROT),
	    .open_AWQOS(soc_open_AWQOS),
	    .open_AWREGION(soc_open_AWREGION),
	    //.open_WVALID(soc_open_WVALID),
	    //.open_WDATA(soc_open_WDATA),
	    //.open_WSTRB(soc_open_WSTRB),
	    .open_WLAST(soc_open_WLAST),
	    //.open_BREADY(soc_open_BREADY),
	    //.open_ARVALID(soc_open_ARVALID),
	    .open_ARID(soc_open_ARID),
	    //.open_ARADDR(soc_open_ARADDR),
	    .open_ARLEN(soc_open_ARLEN),
	    .open_ARSIZE(soc_open_ARSIZE),
	    .open_ARBURST(soc_open_ARBURST),
	    .open_ARLOCK(soc_open_ARLOCK),
	    .open_ARCACHE(soc_open_ARCACHE),
	    //.open_ARPROT(soc_open_ARPROT),
	    .open_ARQOS(soc_open_ARQOS),
	    .open_ARREGION(soc_open_ARREGION),
	    //.open_RREADY(soc_open_RREADY),
	    .debug_master_AWREADY(soc_debug_master_AWREADY),
	    .debug_master_WREADY(soc_debug_master_WREADY),
	    .debug_master_BVALID(soc_debug_master_BVALID),
	    .debug_master_BID(soc_debug_master_BID),
	    .debug_master_BRESP(soc_debug_master_BRESP),
	    .debug_master_ARREADY(soc_debug_master_ARREADY),
	    .debug_master_RVALID(soc_debug_master_RVALID),
	    .debug_master_RID(soc_debug_master_RID),
	    .debug_master_RDATA(soc_debug_master_RDATA),
	    .debug_master_RRESP(soc_debug_master_RRESP),
	    .debug_master_RLAST(soc_debug_master_RLAST),
	    .RDY_debug_server_abstractOperation(soc_RDY_debug_server_abstractOperation),
	    .debug_server_abstractReadResponse(soc_debug_server_abstractReadResponse),
	    .RDY_debug_server_abstractReadResponse(soc_RDY_debug_server_abstractReadResponse),
	    .debug_server_has_reset(soc_debug_server_has_reset),
	    .debug_server_is_halted(soc_debug_server_is_halted),
	    .debug_server_is_unavailable(soc_debug_server_is_unavailable),
	    .io_dump_get(soc_io_dump_get),
	    .RDY_io_dump_get(soc_RDY_io_dump_get),
	    .qspi_io_clk_o(soc_qspi_io_clk_o),
	    .qspi_io_io_o(soc_qspi_io_io_o),
	    .qspi_io_io_enable(soc_qspi_io_io_enable),
	    .qspi_io_ncs_o(soc_qspi_io_ncs_o));

  // submodule sync_request_to_dm
  SyncFIFO1 #(.dataWidth(32'd41)) sync_request_to_dm(.sCLK(CLK_tck_clk),
						     .dCLK(CLK),
						     .sRST(RST_N_trst),
						     .sD_IN(sync_request_to_dm_sD_IN),
						     .sENQ(sync_request_to_dm_sENQ),
						     .dDEQ(sync_request_to_dm_dDEQ),
						     .sFULL_N(sync_request_to_dm_sFULL_N),
						     .dEMPTY_N(sync_request_to_dm_dEMPTY_N),
						     .dD_OUT(sync_request_to_dm_dD_OUT));

  // submodule sync_response_from_dm
  SyncFIFO1 #(.dataWidth(32'd34)) sync_response_from_dm(.sCLK(CLK),
							.dCLK(CLK_tck_clk),
							.sRST(RST_N),
							.sD_IN(sync_response_from_dm_sD_IN),
							.sENQ(sync_response_from_dm_sENQ),
							.dDEQ(sync_response_from_dm_dDEQ),
							.sFULL_N(sync_response_from_dm_sFULL_N),
							.dEMPTY_N(sync_response_from_dm_dEMPTY_N),
							.dD_OUT(sync_response_from_dm_dD_OUT));

  // rule RL_operation
  assign CAN_FIRE_RL_operation =
	     soc_RDY_debug_server_abstractOperation &&
	     debug_module_RDY_hart_abstractOperation ;
  assign WILL_FIRE_RL_operation = CAN_FIRE_RL_operation ;

  // rule RL_response
  assign CAN_FIRE_RL_response =
	     soc_RDY_debug_server_abstractReadResponse &&
	     debug_module_RDY_hart_abstractReadResponse ;
  assign WILL_FIRE_RL_response = CAN_FIRE_RL_response ;

  // rule RL_connect_halt_req
  assign CAN_FIRE_RL_connect_halt_req = 1'd1 ;
  assign WILL_FIRE_RL_connect_halt_req = 1'd1 ;

  // rule RL_connect_resume_req
  assign CAN_FIRE_RL_connect_resume_req = 1'd1 ;
  assign WILL_FIRE_RL_connect_resume_req = 1'd1 ;

  // rule RL_connect_hart_reset
  assign CAN_FIRE_RL_connect_hart_reset = 1'd1 ;
  assign WILL_FIRE_RL_connect_hart_reset = 1'd1 ;

  // rule RL_connect_dm_active
  assign CAN_FIRE_RL_connect_dm_active = 1'd1 ;
  assign WILL_FIRE_RL_connect_dm_active = 1'd1 ;

  // rule RL_rl_rd_addr_channel
  assign CAN_FIRE_RL_rl_rd_addr_channel = 1'd1 ;
  assign WILL_FIRE_RL_rl_rd_addr_channel = 1'd1 ;

  // rule RL_rl_generate_ndmreset
  assign CAN_FIRE_RL_rl_generate_ndmreset = debug_module_getNDMReset ;
  assign WILL_FIRE_RL_rl_generate_ndmreset = debug_module_getNDMReset ;

  // rule RL_assign_jtag_inputs
  assign CAN_FIRE_RL_assign_jtag_inputs = 1'd1 ;
  assign WILL_FIRE_RL_assign_jtag_inputs = 1'd1 ;

  // rule RL_assign_jtag_output
  assign CAN_FIRE_RL_assign_jtag_output = 1'd1 ;
  assign WILL_FIRE_RL_assign_jtag_output = 1'd1 ;

  // rule RL_connect_tap_request_to_syncfifo
  assign CAN_FIRE_RL_connect_tap_request_to_syncfifo =
	     sync_request_to_dm_sFULL_N && jtag_tap_RDY_request_to_dm ;
  assign WILL_FIRE_RL_connect_tap_request_to_syncfifo =
	     CAN_FIRE_RL_connect_tap_request_to_syncfifo ;

  // rule RL_read_synced_request_to_dm
  assign CAN_FIRE_RL_read_synced_request_to_dm =
	     sync_request_to_dm_dEMPTY_N &&
	     debug_module_RDY_dtm_putCommand_put ;
  assign WILL_FIRE_RL_read_synced_request_to_dm =
	     CAN_FIRE_RL_read_synced_request_to_dm && !WILL_FIRE_RL_response ;

  // rule RL_connect_halted
  assign CAN_FIRE_RL_connect_halted = 1'd1 ;
  assign WILL_FIRE_RL_connect_halted = 1'd1 ;

  // rule RL_connect_available
  assign CAN_FIRE_RL_connect_available = 1'd1 ;
  assign WILL_FIRE_RL_connect_available = 1'd1 ;

  // rule RL_connect_has_reset
  assign CAN_FIRE_RL_connect_has_reset = 1'd1 ;
  assign WILL_FIRE_RL_connect_has_reset = 1'd1 ;

  // rule RL_rl_wr_response_channel
  assign CAN_FIRE_RL_rl_wr_response_channel = 1'd1 ;
  assign WILL_FIRE_RL_rl_wr_response_channel = 1'd1 ;

  // rule RL_rl_wr_addr_channel
  assign CAN_FIRE_RL_rl_wr_addr_channel = 1'd1 ;
  assign WILL_FIRE_RL_rl_wr_addr_channel = 1'd1 ;

  // rule RL_rl_wr_data_channel
  assign CAN_FIRE_RL_rl_wr_data_channel = 1'd1 ;
  assign WILL_FIRE_RL_rl_wr_data_channel = 1'd1 ;

  // rule RL_rl_rd_data_channel
  assign CAN_FIRE_RL_rl_rd_data_channel = 1'd1 ;
  assign WILL_FIRE_RL_rl_rd_data_channel = 1'd1 ;

  // rule RL_connect_debug_response_to_syncfifo
  assign CAN_FIRE_RL_connect_debug_response_to_syncfifo =
	     sync_response_from_dm_sFULL_N &&
	     debug_module_RDY_dtm_getResponse_get ;
  assign WILL_FIRE_RL_connect_debug_response_to_syncfifo =
	     CAN_FIRE_RL_connect_debug_response_to_syncfifo ;

  // rule RL_read_synced_response_from_dm
  assign CAN_FIRE_RL_read_synced_response_from_dm =
	     sync_response_from_dm_dEMPTY_N && jtag_tap_RDY_response_from_dm ;
  assign WILL_FIRE_RL_read_synced_response_from_dm =
	     CAN_FIRE_RL_read_synced_response_from_dm ;

  // register tdi
  assign tdi_D_IN = wire_tdi_tdi_in ;
  assign tdi_EN = 1'd1 ;

  // register tdo
  assign tdo_D_IN = jtag_tap_tdo ;
  assign tdo_EN = 1'd1 ;

  // register tms
  assign tms_D_IN = wire_tms_tms_in ;
  assign tms_EN = 1'd1 ;

  // submodule debug_module
  assign debug_module_debug_master_ARREADY = soc_debug_master_ARREADY ;
  assign debug_module_debug_master_AWREADY = soc_debug_master_AWREADY ;
  assign debug_module_debug_master_BID = soc_debug_master_BID ;
  assign debug_module_debug_master_BRESP = soc_debug_master_BRESP ;
  assign debug_module_debug_master_BVALID = soc_debug_master_BVALID ;
  assign debug_module_debug_master_RDATA = soc_debug_master_RDATA ;
  assign debug_module_debug_master_RID = soc_debug_master_RID ;
  assign debug_module_debug_master_RLAST = soc_debug_master_RLAST ;
  assign debug_module_debug_master_RRESP = soc_debug_master_RRESP ;
  assign debug_module_debug_master_RVALID = soc_debug_master_RVALID ;
  assign debug_module_debug_master_WREADY = soc_debug_master_WREADY ;
  assign debug_module_dtm_putCommand_put = sync_request_to_dm_dD_OUT ;
  assign debug_module_hart_abstractReadResponse_abstractResponse =
	     soc_debug_server_abstractReadResponse ;
  assign debug_module_hart_set_halted_halted = soc_debug_server_is_halted ;
  assign debug_module_hart_set_have_reset_have_reset =
	     soc_debug_server_has_reset ;
  assign debug_module_hart_set_unavailable_unavailable =
	     soc_debug_server_is_unavailable ;
  assign debug_module_EN_dtm_putCommand_put =
	     WILL_FIRE_RL_read_synced_request_to_dm ;
  assign debug_module_EN_dtm_getResponse_get =
	     CAN_FIRE_RL_connect_debug_response_to_syncfifo ;
  assign debug_module_EN_hart_abstractOperation = CAN_FIRE_RL_operation ;
  assign debug_module_EN_hart_abstractReadResponse = CAN_FIRE_RL_response ;

  // submodule jtag_tap
  assign jtag_tap_bs_chain_i_bs_chain = 1'd0 ;
  assign jtag_tap_debug_tdi_i_debug_tdi = 1'd0 ;
  assign jtag_tap_response_from_dm_responsedm = sync_response_from_dm_dD_OUT ;
  assign jtag_tap_tdi_i_tdi = tdi ;
  assign jtag_tap_tms_i_tms = tms ;
  assign jtag_tap_EN_debug_tdi_i = 1'd1 ;
  assign jtag_tap_EN_bs_chain_i = 1'd1 ;
  assign jtag_tap_EN_response_from_dm =
	     CAN_FIRE_RL_read_synced_response_from_dm ;
  assign jtag_tap_EN_request_to_dm =
	     CAN_FIRE_RL_connect_tap_request_to_syncfifo ;

  // submodule ndm_reset
  assign ndm_reset_ASSERT_IN = debug_module_getNDMReset ;

  // submodule soc
  assign soc_boot_config = boot_config ;
  assign soc_ddr_ARREADY = ddr_ARREADY ;
  assign soc_ddr_AWREADY = ddr_AWREADY ;
  assign soc_ddr_BID = ddr_BID ;
  assign soc_ddr_BRESP = ddr_BRESP ;
  assign soc_ddr_BVALID = ddr_BVALID ;
  assign soc_ddr_RDATA = ddr_RDATA ;
  assign soc_ddr_RID = ddr_RID ;
  assign soc_ddr_RLAST = ddr_RLAST ;
  assign soc_ddr_RRESP = ddr_RRESP ;
  assign soc_ddr_RVALID = ddr_RVALID ;
  assign soc_ddr_WREADY = ddr_WREADY ;
  assign soc_debug_master_ARADDR = debug_module_debug_master_ARADDR ;
  assign soc_debug_master_ARBURST = debug_module_debug_master_ARBURST ;
  assign soc_debug_master_ARCACHE = debug_module_debug_master_ARCACHE ;
  assign soc_debug_master_ARID = debug_module_debug_master_ARID ;
  assign soc_debug_master_ARLEN = debug_module_debug_master_ARLEN ;
  assign soc_debug_master_ARLOCK = debug_module_debug_master_ARLOCK ;
  assign soc_debug_master_ARPROT = debug_module_debug_master_ARPROT ;
  assign soc_debug_master_ARQOS = debug_module_debug_master_ARQOS ;
  assign soc_debug_master_ARREGION = debug_module_debug_master_ARREGION ;
  assign soc_debug_master_ARSIZE = debug_module_debug_master_ARSIZE ;
  assign soc_debug_master_ARVALID = debug_module_debug_master_ARVALID ;
  assign soc_debug_master_AWADDR = debug_module_debug_master_AWADDR ;
  assign soc_debug_master_AWBURST = debug_module_debug_master_AWBURST ;
  assign soc_debug_master_AWCACHE = debug_module_debug_master_AWCACHE ;
  assign soc_debug_master_AWID = debug_module_debug_master_AWID ;
  assign soc_debug_master_AWLEN = debug_module_debug_master_AWLEN ;
  assign soc_debug_master_AWLOCK = debug_module_debug_master_AWLOCK ;
  assign soc_debug_master_AWPROT = debug_module_debug_master_AWPROT ;
  assign soc_debug_master_AWQOS = debug_module_debug_master_AWQOS ;
  assign soc_debug_master_AWREGION = debug_module_debug_master_AWREGION ;
  assign soc_debug_master_AWSIZE = debug_module_debug_master_AWSIZE ;
  assign soc_debug_master_AWVALID = debug_module_debug_master_AWVALID ;
  assign soc_debug_master_BREADY = debug_module_debug_master_BREADY ;
  assign soc_debug_master_RREADY = debug_module_debug_master_RREADY ;
  assign soc_debug_master_WDATA = debug_module_debug_master_WDATA ;
  assign soc_debug_master_WLAST = debug_module_debug_master_WLAST ;
  assign soc_debug_master_WSTRB = debug_module_debug_master_WSTRB ;
  assign soc_debug_master_WVALID = debug_module_debug_master_WVALID ;
  assign soc_debug_server_abstractOperation_cmd =
	     debug_module_hart_abstractOperation ;
  assign soc_debug_server_dm_active_dm_active = debug_module_hart_dm_active ;
  assign soc_debug_server_haltRequest_halt_request =
	     debug_module_hart_dm_active && debug_module_hart_haltRequest ;
  assign soc_debug_server_hartReset_hart_reset_v =
	     debug_module_hart_dm_active && debug_module_hart_hart_reset ;
  assign soc_debug_server_resumeRequest_resume_request =
	     debug_module_hart_dm_active && debug_module_hart_resumeRequest ;
  assign soc_gpio_in_val = gpio_in_val ;
  assign soc_open_ARREADY = open_ARREADY ;
  assign soc_open_AWREADY = open_AWREADY ;
  assign soc_open_BID = open_BID ;
  assign soc_open_BRESP = open_BRESP ;
  assign soc_open_BVALID = open_BVALID ;
  assign soc_open_RDATA = open_RDATA ;
  assign soc_open_RID = open_RID ;
  assign soc_open_RLAST = open_RLAST ;
  assign soc_open_RRESP = open_RRESP ;
  assign soc_open_RVALID = open_RVALID ;
  assign soc_open_WREADY = open_WREADY ;
  assign soc_qspi_io_io_i_io_i = qspi_io_io_i_io_i ;
  assign soc_uart0_SIN = uart0_SIN ;
  assign soc_EN_debug_server_abstractOperation = CAN_FIRE_RL_operation ;
  assign soc_EN_debug_server_abstractReadResponse = CAN_FIRE_RL_response ;
  assign soc_EN_io_dump_get = EN_io_dump_get ;

  // submodule sync_request_to_dm
  assign sync_request_to_dm_sD_IN = { 1'd0, jtag_tap_request_to_dm } ;
  assign sync_request_to_dm_sENQ =
	     CAN_FIRE_RL_connect_tap_request_to_syncfifo ;
  assign sync_request_to_dm_dDEQ = WILL_FIRE_RL_read_synced_request_to_dm ;

  // submodule sync_response_from_dm
  assign sync_response_from_dm_sD_IN = debug_module_dtm_getResponse_get ;
  assign sync_response_from_dm_sENQ =
	     CAN_FIRE_RL_connect_debug_response_to_syncfifo ;
  assign sync_response_from_dm_dDEQ =
	     CAN_FIRE_RL_read_synced_response_from_dm ;

  // handling of inlined registers

  always@(posedge CLK)
  begin
    if (RST_N == `BSV_RESET_VALUE)
      begin
        tdi <= `BSV_ASSIGNMENT_DELAY 1'd0;
	tms <= `BSV_ASSIGNMENT_DELAY 1'd0;
      end
    else
      begin
        if (tdi_EN) tdi <= `BSV_ASSIGNMENT_DELAY tdi_D_IN;
	if (tms_EN) tms <= `BSV_ASSIGNMENT_DELAY tms_D_IN;
      end
  end

  always@(posedge CLK_tck_clk)
  begin
    if (RST_N_trst == `BSV_RESET_VALUE)
      begin
        tdo <= `BSV_ASSIGNMENT_DELAY 1'd0;
      end
    else
      begin
        if (tdo_EN) tdo <= `BSV_ASSIGNMENT_DELAY tdo_D_IN;
      end
  end

  // synopsys translate_off
  `ifdef BSV_NO_INITIAL_BLOCKS
  `else // not BSV_NO_INITIAL_BLOCKS
  initial
  begin
    tdi = 1'h0;
    tdo = 1'h0;
    tms = 1'h0;
  end
  `endif // BSV_NO_INITIAL_BLOCKS
  // synopsys translate_on

  // handling of system tasks

  // synopsys translate_off
  always@(negedge CLK)
  begin
    #0;
    if (RST_N != `BSV_RESET_VALUE)
      if (debug_module_RST_N_dmactive_reset != `BSV_RESET_VALUE)
	if (debug_module_getNDMReset)
	  begin
	    TASK_testplusargs___d64 = $test$plusargs("fullverbose");
	    #0;
	  end
    if (RST_N != `BSV_RESET_VALUE)
      if (debug_module_RST_N_dmactive_reset != `BSV_RESET_VALUE)
	if (debug_module_getNDMReset)
	  begin
	    TASK_testplusargs___d65 = $test$plusargs("mdebugsoc");
	    #0;
	  end
    if (RST_N != `BSV_RESET_VALUE)
      if (debug_module_RST_N_dmactive_reset != `BSV_RESET_VALUE)
	if (debug_module_getNDMReset)
	  begin
	    TASK_testplusargs___d66 = $test$plusargs("l0");
	    #0;
	  end
    if (RST_N != `BSV_RESET_VALUE)
      if (debug_module_RST_N_dmactive_reset != `BSV_RESET_VALUE)
	if (debug_module_getNDMReset)
	  begin
	    v__h3325 = $time;
	    #0;
	  end
    if (RST_N != `BSV_RESET_VALUE)
      if (debug_module_RST_N_dmactive_reset != `BSV_RESET_VALUE)
	if (debug_module_getNDMReset &&
	    (TASK_testplusargs___d64 ||
	     TASK_testplusargs___d65 && TASK_testplusargs___d66))
	  $write("[%10d", v__h3325, "] ");
    if (RST_N != `BSV_RESET_VALUE)
      if (debug_module_RST_N_dmactive_reset != `BSV_RESET_VALUE)
	if (debug_module_getNDMReset &&
	    (TASK_testplusargs___d64 ||
	     TASK_testplusargs___d65 && TASK_testplusargs___d66))
	  $write("DebubSoc: Asserting NDM Reset");
    if (RST_N != `BSV_RESET_VALUE)
      if (debug_module_RST_N_dmactive_reset != `BSV_RESET_VALUE)
	if (debug_module_getNDMReset &&
	    (TASK_testplusargs___d64 ||
	     TASK_testplusargs___d65 && TASK_testplusargs___d66))
	  $write("\n");
  end
  // synopsys translate_on
endmodule  // mkDebugSoc

